/*
 SpryDOMEffects.js - version 0.6 - Spry Pre-Release 1.7

 Copyright (c) 2007. Adobe Systems Incorporated.
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.
 Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation
 and/or other materials provided with the distribution.
 Neither the name of Adobe Systems Incorporated nor the names of its
 contributors may be used to endorse or promote products derived from this
 software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 POSSIBILITY OF SUCH DAMAGE.
*/
(function(){if(typeof Spry=="undefined"||!Spry.Utils||!Spry.$$)alert("SpryDOMEffects.js requires SpryDOMUtils.js");else{if(!Spry.Effect)Spry.Effect={};Spry.Effect.Animator=function(a){Spry.Effect.Animator.Notifier.call(this);this.animatorID=Spry.Effect.Animator.nextID++;this.dropFrames=!0;this.fps=60;this.duration=500;this.currentFrame=this.startTime=this.timer=0;this.easeFunc=Spry.Effect.Animator.defaultEaseFunc;this.stopped=!1;Spry.Effect.Animator.copyProps(this,a);this.interval=1E3/this.fps;this.numFrames=
this.duration/1E3*this.fps;if(this.onComplete){var b=this;this.addObserver({onAnimationComplete:function(){b.onComplete()}})}};Spry.Effect.Animator.nextID=1;Spry.Effect.Animator.copyProps=function(a,b){if(b)for(prop in b)a[prop]=b[prop];return a};Spry.Effect.Animator.getElement=function(a){if(arguments.length>1){for(var b=0,c=[],d=arguments.length;b<d;b++)c.push(Spry.Effect.Animator.getElement(arguments[b]));return c}typeof a=="string"&&(a=document.getElementById(a));return a};Spry.Effect.Animator.defaultEaseFunc=
function(a,b,c,d){a/=d;return b+(2-a)*a*c};Spry.Effect.Animator.Notifier=function(){this.observers=[];this.suppressNotifications=0};Spry.Effect.Animator.Notifier.prototype.addObserver=function(a){if(a){for(var b=this.observers.length,c=0;c<b;c++)if(this.observers[c]==a)return;this.observers[b]=a}};Spry.Effect.Animator.Notifier.prototype.removeObserver=function(a){if(a)for(var b=0;b<this.observers.length;b++)if(this.observers[b]==a){this.observers.splice(b,1);break}};Spry.Effect.Animator.Notifier.prototype.notifyObservers=
function(a,b){if(a&&!this.suppressNotifications)for(var c=this.observers.length,d=0;d<c;d++){var e=this.observers[d];if(e)if(typeof e=="function")e(a,this,b);else if(e[a])e[a](this,b)}};Spry.Effect.Animator.Notifier.prototype.enableNotifications=function(){if(--this.suppressNotifications<0)this.suppressNotifications=0,Spry.Debug.reportError("Unbalanced enableNotifications() call!\n")};Spry.Effect.Animator.Notifier.prototype.disableNotifications=function(){++this.suppressNotifications};Spry.Effect.Animator.prototype=
new Spry.Effect.Animator.Notifier;Spry.Effect.Animator.prototype.constructor=Spry.Effect.Animator;Spry.Effect.Animator.prototype.start=function(){this.stopped=!1;this.currentFrame=0;this.startTime=(new Date).getTime();this.notifyObservers("onAnimationStart");var a=this;this.timer=setTimeout(function(){a.onStepAnimation()},this.interval)};Spry.Effect.Animator.prototype.stop=function(){this.timer&&clearTimeout(this.timer);this.timer=0;this.stopped=!0;this.notifyObservers("onAnimationStopped")};Spry.Effect.Animator.prototype.onStepAnimation=
function(){var a={};if(this.dropFrames){if(a.duration=this.duration,a.elapsed=(new Date).getTime()-this.startTime,a.elapsed>a.duration)a.elapsed=a.duration}else a.duration=this.numFrames,a.elapsed=++this.currentFrame;a.easingConst=this.easeFunc(a.elapsed,0,1,a.duration);this.notifyObservers("onPreDraw",a);this.draw(a.elapsed,a.duration,a.easingConst);this.notifyObservers("onPostDraw",a);if(!this.stopped)if(a.elapsed<a.duration){var b=this;this.timer=setTimeout(function(){b.onStepAnimation()},this.interval)}else this.stop(),
this.notifyObservers("onAnimationComplete")};Spry.Effect.Animator.prototype.draw=function(a,b,c){debug.log("elapsed: "+a+" -- duration: "+b+" -- easingConst: "+c)};Spry.Effect.CSSAnimator=function(a,b,c){this.animationSets=[];Spry.Effect.Animator.call(this,c);this.add(a,b)};Spry.Effect.CSSAnimator.prototype=new Spry.Effect.Animator;Spry.Effect.CSSAnimator.prototype.constructor=Spry.Effect.CSSAnimator;Spry.Effect.CSSAnimator.prototype.add=function(a,b){a=Spry.$$(a);if(!(a.length<1)){var c={elements:a,
cssProps:[]};this.animationSets.push(c);var d=Spry.Utils.styleStringToObject(b),e;for(e in d){var f={},g=d[e];f.value=new Number(g.replace(/[^-\d\.]+/g,""));f.units=g.replace(/[-\d+\.]/g,"");d[e]=f}for(g=0;g<a.length;g++)for(e in f=c.cssProps[g]={},d){var h=Spry.Effect.CSSAnimator.stylePropFuncs[e];h||(h=Spry.Effect.CSSAnimator.stylePropFuncs["default"]);f[e]={};f[e].from=new Number(h.get(a[g],e).replace(/[^-\d\.]+/g,""));f[e].to=d[e].value;f[e].distance=f[e].to-f[e].from;f[e].units=d[e].units}}};
Spry.Effect.CSSAnimator.prototype.start=function(){for(var a=0;a<this.animationSets.length;a++)for(var b=this.animationSets[a],c=b.elements,b=b.cssProps,d=0;d<c.length;d++){var e=c[d],f=e.spryCSSAnimatorProps;if(!f)f=e.spryCSSAnimatorProps={};var e=b[d],g;for(g in e)f[g]=this.animatorID}return Spry.Effect.Animator.prototype.start.call(this)};Spry.Effect.CSSAnimator.prototype.stop=function(){for(var a=0;a<this.animationSets.length;a++)for(var b=this.animationSets[a],c=b.elements,b=b.cssProps,d=0;d<
c.length;d++){var e=b[d],f=c[d].spryCSSAnimatorProps,g;for(g in e)f[g]==this.animatorID&&delete f[g]}return Spry.Effect.Animator.prototype.stop.call(this)};Spry.Effect.CSSAnimator.prototype.draw=function(a,b,c){for(var d=0;d<this.animationSets.length;d++)for(var e=this.animationSets[d],f=e.elements,e=e.cssProps,g=0;g<f.length;g++){var h=f[g],i=h.spryCSSAnimatorProps,j=e[g],k;for(k in j)if(i[k]==this.animatorID){var l=Spry.Effect.CSSAnimator.stylePropFuncs[k];l||(l=Spry.Effect.CSSAnimator.stylePropFuncs["default"]);
a>b?l.set(h,k,j[k].to+j[k].units):l.set(h,k,j[k].from+j[k].distance*c+j[k].units)}}};Spry.Effect.CSSAnimator.stylePropFuncs={};Spry.Effect.CSSAnimator.stylePropFuncs["default"]={get:function(a,b){return a.style[b]},set:function(a,b,c){a.style[b]=c}};Spry.Effect.CSSAnimator.stylePropFuncs.opacity={get:function(a){var b=1;a.style.opacity?b=a.style.opacity:a.style.filter&&(a=a.style.filter.replace(/.*alpha\(opacity=(\d+)\).*/,"$1"))&&(b=parseInt(a)/100);return b+""},set:function(a,b,c){a.style.opacity=
""+c;a.style.filter="alpha(opacity="+c*100+")"}};Spry.$$.Results.defaultEaseFunc=function(a,b,c,d){a/=d;return b+(2-a)*a*c};Spry.$$.Results.animatePropertyTo=function(a,b,c){var d={interval:10,duration:1E3,onComplete:null,transition:Spry.$$.Results.defaultEaseFunc};Spry.Effect.Animator.copyProps(d,c);for(var e=[],c=0;c<this.length;c++){var f=e[c]={};f.ele=this[c];f.from=f.ele[a];f.distance=b-f.from}var g=(new Date).getTime(),h=function(){var c=(new Date).getTime()-g;if(c>d.duration){for(var f=0;f<
e.length;f++)e[f].ele[a]=b;if(d.onComplete)d.onComplete()}else{for(f=0;f<e.length;f++){var k=e[f];k.ele[a]=d.transition(c,k.from,k.distance,d.duration)}setTimeout(h,d.interval)}};setTimeout(h,d.interval);return this};Spry.$$.Results.animateStyleTo=function(a,b){(new Spry.Effect.CSSAnimator(this,a,b)).start();return this}}})();
